﻿Public Class Base1 '自機、敵、ボス用の基本(ついでにアイテムも)

    Inherits Base

    Private _vec_x As Integer   '速度ベクトル_x

    Public Property vec_x() As Integer
        Get
            Return _vec_x
        End Get
        Set(ByVal value As Integer)
            _vec_x = value
        End Set
    End Property

    Private _vec_y As Integer   '速度ベクトル_y

    Public Property vec_y() As Integer
        Get
            Return _vec_y
        End Get
        Set(ByVal value As Integer)
            _vec_y = value
        End Set
    End Property

    Private _vec_z As Integer   '速度ベクトル_z

    Public Property vec_z() As Integer
        Get
            Return _vec_z
        End Get
        Set(ByVal value As Integer)
            _vec_z = value
        End Set
    End Property

    Private _HP As Integer   '生命力的なもの

    Public Property HP() As Integer
        Get
            Return _HP
        End Get
        Set(ByVal value As Integer)
            _HP = value
        End Set
    End Property

    Private _action As Integer   '動作の分類用

    Public Property action() As Integer
        Get
            Return _action
        End Get
        Set(ByVal value As Integer)
            _action = value
        End Set
    End Property

    Public Sub New()
        Me.x = 0
        Me.y = 0
        Me.z = 0
        Me.vec_x = 0
        Me.vec_y = 0
        Me.vec_z = 0
        Me.exist = False
        Me.kind = 0
        Me.HP = 0
        Me.size = 0
        Me.action = 0

    End Sub

    '存在しなくなったらみんな0の状態にしておく
    Public Sub disappear()
        Me.x = 0
        Me.y = 0
        Me.z = 0
        Me.vec_x = 0
        Me.vec_y = 0
        Me.vec_z = 0
        Me.exist = False
        Me.kind = 0
        Me.HP = 0
        Me.size = 0
        Me.action = 0
    End Sub

    'ベクトルの入力用
    Public Sub set_v(ByVal in_vec_x As Integer, ByVal in_vec_y As Integer, ByVal in_vec_z As Integer)

        Me.vec_x = in_vec_x
        Me.vec_y = in_vec_y
        Me.vec_z = in_vec_z

    End Sub

    '状態の入力用
    Public Sub set_s(ByVal in_exist As Boolean, ByVal in_kind As Integer, _
                     ByVal in_HP As Integer, ByVal in_size As Integer, ByVal in_action As Integer)

        Me.exist = in_exist   '存在フラグ
        Me.kind = in_kind     '種類
        Me.HP = in_HP   'ヒットポイント
        Me.size = in_size   '大きさ
        Me.action = in_action      '動作用

    End Sub

    Public Sub move_base()
        '各軸方向の速度を座標に反映、用は動かすよってことで
        Me.x += Me.vec_x
        Me.y += Me.vec_y
        Me.z += Me.vec_z

    End Sub

    Public Sub gravity()
        '重力的な動作、床との反射を担当
        If Me.exist Then
            If Me.y + Me.size + Me.vec_y < c.y_max Then
                If Me.vec_y < 30 Then
                    Me.vec_y += 2 'これが重力による加速
                Else
                    Me.vec_y = 30     '落下で加速してもこれ以上速くならないよー
                End If
            Else
                Me.y = c.y_max - Me.size
                If Me.vec_y > 0 Then
                    vec_y = -2 * Math.Abs(Me.vec_y - 1) \ 3 '速度を半減して反射、だんだん落ち着いてくる(-1するのはvec_y = 1のときに延々+-1を繰り返してしまうので)
                End If
            End If

        End If

    End Sub

End Class
