﻿Public Class Bullet
    '弾(敵、自機)

    Inherits Base2

    'ステージに出現してない弾の、配列そ添え字番号を返してくれます
    Public Shared Function free_check() As Integer

        Dim check As Integer = 0  'どの弾もフリーではなかったら、0番さんが犠牲になります

        For i As Integer = 0 To c.bull_num - 1
            If c.bullet(i).exist = False Then
                check = i
                Exit For
            End If
        Next

        Return check

    End Function

    '引数で設定して、出現させます
    Public Shared Sub appear(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer,
                              ByVal vec_x As Single, ByVal vec_y As Integer, ByVal vec_z As Single,
                              ByVal kind As Integer, ByVal size As Integer, ByVal action As Integer)
        Dim i As Integer = free_check()
        c.bullet(i).set_c(x, y, z)
        c.bullet(i).set_v(vec_x, vec_y, vec_z)
        c.bullet(i).set_s(True, kind, size, action)
    End Sub


    Public Shared Sub jiki_bull_set(ByVal pattern As Integer, ByVal judge As Boolean, ByRef bull_time As Integer)
        'patternで弱弾、強弾、のどっちに用があるか見極める
        'judgeに用があるほうのスイッチになってるkey_judge()を入れる
        'bull_timeは用のあるほうの待ち時間計測変数(JIKIクラスにおいてある)
        Select Case pattern
            Case 0
                If bull_time < 2 Then
                    bull_time += 1
                End If
            Case 1
                If bull_time < 10 Then '前の発射から時間が経ったら
                    bull_time += 1
                End If
        End Select

        If judge Then
            Select Case pattern
                Case 0
                    If bull_time >= 2 Then   '前の発射から時間が経ったら
                        bull_time = 0
                        If c.count Mod 3 = 0 Then
                        End If
                        appear(c.jiki.x + (c.l_size - c.s_size) \ 2, c.jiki.y + (c.l_size - c.s_size) \ 2, c.jiki.z + 5, _
                                 0, 0, 30, _
                                 0, c.s_size, 0)
                    End If
                Case 1
                    If bull_time >= 10 And c.score > 100 Then  '前の発射から時間が経ったら
                        bull_time = 0
                        c.score -= 100    '強弾はscoreを消費
                        For i As Integer = 0 To 14
                            appear(c.jiki.x + (-1 + (i Mod 3)) * c.s_size + (c.l_size - c.s_size) \ 2, c.jiki.y + (c.l_size - c.s_size) \ 2, c.jiki.z + 5, _
                                   0, 0, 50 - (i \ 3), _
                                   1, c.s_size, 0)
                            '5行3列みたいな感じに配置、速度が行ごとに遅くなるから進んでいくうちに縦にばらける
                        Next
                        Bullet.set_circle(c.jiki.x + c.l_size \ 2, c.jiki.y + c.l_size \ 2, c.jiki.z, 0, c.s_size, 100, 1, 100, 0)

                        '強弾を打つと自機周辺の敵所属の弾と敵が消える
                        For i As Integer = 0 To c.bull_num - 1
                            If c.bullet(i).kind >= 2 And Math.Abs(c.jiki.x + c.l_size \ 2 - c.bullet(i).x) + Math.Abs(c.jiki.y + c.l_size \ 2 - c.bullet(i).y) + Math.Abs(c.jiki.z - c.bullet(i).z) <= 400 And c.bullet(i).kind <> 3 Then
                                effect.appear(c.bullet(i).x, c.bullet(i).y, c.bullet(i).z, c.bullet(i).size)
                                c.bullet(i).disappear()
                            End If
                        Next
                        For i As Integer = 0 To c.teki_num - 1
                            If Math.Abs(c.jiki.x + c.l_size \ 2 - c.teki(i).x) + Math.Abs(c.jiki.y + c.l_size \ 2 - c.teki(i).y) + Math.Abs(c.jiki.z - c.teki(i).z) <= 400 And c.teki(i).kind <> 1 And Not (c.teki(i).kind = 2 And c.teki(i).action = 2) Then
                                effect.appear(c.teki(i).x, c.teki(i).y, c.teki(i).z, c.teki(i).size)
                                c.teki(i).disappear()
                            End If
                        Next

                    End If
            End Select
        End If
    End Sub

    Public Shared Sub move()  '移動と消滅をまとめてやっちゃいます
        For i As Integer = 0 To c.bull_num - 1
            If c.bullet(i).exist Then
                '表に出てる奴だけ動かします

                c.bullet(i).move_base()

                'ゲームステージ上からはみ出たら消えていただきます。また使う日までさようなら(^o^)ノシ
                If c.bullet(i).kind <= 1 Then    '自機所属の弾はz方向(奥)にしか飛ばないので..
                    If c.bullet(i).z > c.z_max Then
                        c.bullet(i).disappear()
                    End If
                    If c.bullet(i).action = 1 Then
                        If Math.Abs(c.jiki.x + c.l_size - c.bullet(i).x) + Math.Abs(c.jiki.z - c.bullet(i).z) >= 400 Then
                            c.bullet(i).disappear()
                        End If
                    End If
                    '強弾は射程短い
                    If c.bullet(i).kind = 1 Then
                        If Math.Abs(c.jiki.z - c.bullet(i).z) >= 500 Then
                            c.bullet(i).disappear()
                        End If
                    End If
                Else
                    '敵、ボス、所属の弾は前後左右どの方向へも進むので
                    If c.bullet(i).x < 0 Or c.bullet(i).x > c.x_max - c.bullet(i).size Or _
                        c.bullet(i).z < 0 Or c.bullet(i).z > c.z_max Then
                        c.bullet(i).disappear()
                    End If
                End If
            End If

        Next

    End Sub

    'この先は弾幕生成用の関数置き場でございます

    '指定座標1から指定座標2へ向けて撃つ
    Public Shared Sub ptp(ByVal x1 As Integer, ByVal y1 As Integer, ByVal z1 As Integer,
                          ByVal x2 As Integer, ByVal z2 As Integer,
                          ByVal kind As Integer, ByVal size As Integer, ByVal speed As Integer, ByVal action As Integer)
        Dim theta As Single = Math.Atan2(CDbl(z2 - z1), CDbl(x2 - x1 + size \ 2))

        appear(x1 + size \ 2, y1 + size \ 2, z1, _
               speed * Math.Cos(theta), 0, speed * Math.Sin(theta), _
               kind, size, action)
    End Sub

    '360度で　射出角度を指定
    Public Shared Sub set_deg(ByVal x1 As Integer, ByVal y1 As Integer, ByVal z1 As Integer, ByVal deg As Integer,
                          ByVal kind As Integer, ByVal size As Integer, ByVal speed As Integer, ByVal action As Integer)
        appear(x1 + size \ 2, y1 + size \ 2, z1, _
               speed * Math.Cos(deg * Math.PI / 180), 0, speed * Math.Sin(deg * Math.PI / 180), _
               kind, size, action)
    End Sub

    '指定座標に、指定したスピード、種類の自機狙いな弾を生成します
    Public Shared Sub set_to_jiki(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer,
                                  ByVal kind As Integer, ByVal size As Integer, ByVal speed As Integer, ByVal action As Integer)

        'thetaに水平面上に取れる、自機と発射地点のなす角度を作ります
        Dim theta As Single = Math.Atan2(CDbl(c.jiki.z - z), CDbl(c.jiki.x + c.jiki.size \ 2 - (x + size \ 2)))

        appear(x, y, z, _
               speed * Math.Cos(theta), 0, speed * Math.Sin(theta), _
               kind, size, action)
    End Sub

    '指定点から丸く広がっていく
    Public Shared Sub set_circle(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer, _
                                 ByVal kind As Integer, ByVal size As Integer, ByVal speed As Integer, ByVal action As Integer,
                                 ByVal deg As Integer, ByVal upper As Integer)
        'deg:次の弾までの角度設定用(一周を何分割するか)
        'upperを正の値にすると噴水みたいになる

        For i As Integer = 0 To deg - 1
            appear(x, y, z, _
                   Math.Cos((2 * Math.PI / deg) * i) * speed, -1 * upper, Math.Sin((2 * Math.PI / deg) * i) * speed, _
                   kind, size, action)
        Next
    End Sub

    '指定座標に、指定したスピード、種類で、指定したz座標でいっぱいに広がるように動く弾幕を生成
    Public Shared Sub set_wide(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer, _
                               ByVal kind As Integer, ByVal size As Integer, ByVal speed As Integer, ByVal action As Integer,
                               ByVal to_z As Integer, ByVal density As Integer)
        'densityはばらまく数。最大で60までにしよう

        Dim d As Integer = c.x_max \ density

        For i As Integer = 0 To density - 1
            'thetaに水平面上に取れる、目標地点と発射地点のなす角度を作ります
            Dim theta As Single = Math.Atan2(CDbl(to_z - z), CDbl(d * i - x))

            appear(x, y, z, _
                   speed * Math.Cos(theta), 0, speed * Math.Sin(theta), _
                   kind, size, action)
        Next

    End Sub





End Class
